%global	eclipse_dropins	%{_datadir}/eclipse/dropins
%global	build_base	build/.m2/org/jboss/tools/

Name:		eclipse-jbosstools
Version:	3.3.1
Release:	1%{?dist}
Summary:	A set of Eclipse plugins that supports JBoss and related technology

Group:		Development/Tools

# For mult. license info, see https://community.jboss.org/thread/158037
License:	EPL and LGPLv2+ and ASL and MPL
URL:		http://www.jboss.org/tools.html

# svn export http://anonsvn.jboss.org/repos/jbosstools/tags/jbosstools-3.3.0.Final/ eclipse-jbosstools-3.3.0.Final
# tar -cJf eclipse-jbosstools-3.3.0.Final.tar.xz eclipse-jbosstools-3.3.0.Final/
Source0:	%{name}-%{version}.Final.tar.xz

# Comment out unsatisfiable dep: ant-optional
# Comment out some external repositories (not sure if this is necessary...)
# Change versions of some deps to match fedora packages
Patch0:		%{name}-parent-pom.patch
Patch1:		%{name}-target-platform.patch

# Without one of the following patches, the following error prevents building:
# [ERROR] Internal error: java.lang.RuntimeException: Could not determine SWT implementation fragment bundle
Patch2:		%{name}-x86_64.patch
Patch3:		%{name}-x86.patch

# These patches all similarly comment out stuff that prevents building. It's
# mainly stuff that we don't need immediately anyway (site,tests modules)
Patch4:		%{name}-common.patch
Patch5:		%{name}-usage.patch
Patch6:		%{name}-archives.patch
Patch7:		%{name}-jmx.patch
Patch8:		%{name}-as.patch
Patch9:		%{name}-jst.patch
Patch10:	%{name}-ws.patch
Patch11:	%{name}-cdi.patch
Patch12:	%{name}-freemarker.patch

# This patch seems to have been included in upstream trunk already
# http://web.archiveorange.com/archive/v/yXYbUiLHbz40Q1bDwhSS
Patch13:	%{name}-as-methodVisibility.patch

# Update refs from old bundled deps in archives, to symlinked deps from Fedora
Patch14:	%{name}-archives-core-manifest.patch
Patch15:	%{name}-archives-core-buildproperties.patch

# Migrate to from obselete to current version of TrueZip dependency
Patch16:	%{name}-archives-core-trueziputil.patch
Patch17:	%{name}-archives-core-modeltruezipbridge.patch
Patch18:	%{name}-archives-core-archivesbuilder.patch
Patch19:	%{name}-as-archives.webtools.patch

# Add unimplemented methods from updated jbossxb dependency
Patch20:	%{name}-archives-core-ArchivesUnmarshallerImpl.patch

# Update refs from old bundled deps in AS, to symlinked deps from Fedora
Patch21:	%{name}-as.dmr.patch
Patch22:	%{name}-as.core.patch
Patch23:	%{name}-as.mgmt.as71.patch

BuildRequires:	ant >= 1.8.3
BuildRequires:	ant-contrib >= 0.16.b3
BuildRequires:	axis >= 1.4-16
BuildRequires:	dom4j >= 1.6.1-8
BuildRequires:	eclipse-dtp >= 1.10
BuildRequires:	eclipse-emf-core >= 2.8.0
BuildRequires:	eclipse-emf-sdk >= 2.8.0
BuildRequires:	eclipse-gef >= 3.8.0
BuildRequires:	eclipse-jdt >= 4.2.0
BuildRequires:	eclipse-pde >= 4.2.0
BuildRequires:	eclipse-platform >= 4.2.0
BuildRequires:	eclipse-rcp > 4.2.0
BuildRequires:	eclipse-rse >= 3.3.1
BuildRequires:	eclipse-swt >= 4.2.0
BuildRequires:	eclipse-wtp-common >= 3.4.0
BuildRequires:	eclipse-wtp-jeetools >= 3.4.0
BuildRequires:	eclipse-wtp-jpa >= 3.4.0
BuildRequires:	eclipse-wtp-jsf >= 3.4.0
BuildRequires:	eclipse-wtp-jst-web >= 3.4.0
BuildRequires:	eclipse-wtp-servertools >= 3.4.0
BuildRequires:	eclipse-wtp-webservices >= 3.4.0
BuildRequires:	eclipse-wtp-sourceediting >= 3.4.0
BuildRequires:	gnu-getopt >= 1.0.13
BuildRequires:	icu4j-eclipse >= 4.4.2.2
BuildRequires:	jacoco-maven-plugin
BuildRequires:	jakarta-commons-httpclient >= 3.1
BuildRequires:	java-devel
BuildRequires:	jaxen >= 1.1.3
BuildRequires:	jboss-as >= 7.1.1-3
BuildRequires:	jboss-dmr >= 1.1.1
BuildRequires:	jbossxb >= 2.0.3
BuildRequires:	jpackage-utils
BuildRequires:	maven
BuildRequires:	maven-jar-plugin
BuildRequires:	maven-install-plugin
BuildRequires:	maven-javadoc-plugin
BuildRequires:	maven-release-plugin
BuildRequires:	maven-compiler-plugin
BuildRequires:	maven-surefire-plugin
BuildRequires:	maven-resources-plugin
BuildRequires:	resteasy >= 2.3.2-7
BuildRequires:	truezip-driver-zip >= 7.5.5
BuildRequires:	truezip-file >= 7.5.5
BuildRequires:	tycho
BuildRequires:	tycho-extras
BuildRequires:	velocity >= 1.7-4
BuildRequires:	xerces-j2 >= 2.11.0-7

Requires:	java
Requires:	jpackage-utils

Requires:	%{name}-archives = %{version}-%{release}
Requires:	%{name}-as = %{version}-%{release}
Requires:	%{name}-cdi = %{version}-%{release}
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-freemarker = %{version}-%{release}
Requires:	%{name}-jmx = %{version}-%{release}
Requires:	%{name}-jst = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	%{name}-ws = %{version}-%{release}

%description
JBoss Tools is an umbrella project for a set of Eclipse plugins that supports
JBoss and related technology; there is support for Hibernate, JBoss AS, Drools, 
jBPM, JSF, (X)HTML, Seam, Maven, JBoss ESB, JBoss Portal and more...

%package	parent
Summary:	JBoss Tools Parent
Requires:	jpackage-utils

%description parent
Parent and target-platform POM files for %{name} package.

%package	common
Summary:	JBoss Tools common Eclipse tools

Requires:	%{name}-parent = %{version}-%{release}
Requires:	eclipse-gef
Requires:	eclipse-jdt
Requires:	eclipse-platform
Requires:	eclipse-pde
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	eclipse-wtp-common
Requires:	eclipse-wtp-jeetools
Requires:	eclipse-wtp-jpa
Requires:	eclipse-wtp-sourceediting
Requires:	jakarta-commons-httpclient
Requires:	java
Requires:	jpackage-utils
Requires:	xerces-j2

%description common
Common functionality on which other plugins and features from %{name} depend.

%package	jmx
Summary:	Eclipse tools for interacting with JMX connections

Requires:	%{name}-parent = %{version}-%{release}
Requires:	eclipse-platform
Requires:	eclipse-swt
Requires:	java
Requires:	jpackage-utils

%description jmx
JBoss JMX Tools allows you to setup multiple JMX connections, and provides a
view for exploring the JMX tree and execute operations directly from within
Eclipse.

%package	archives
Summary:	JBoss Archives Tools

Requires:	%{name}-as = %{version}-%{release}
Requires:	%{name}-jmx = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	ant
Requires:	eclipse-emf-core
Requires:	eclipse-jdt
Requires:	eclipse-pde
Requires:	eclipse-platform
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	eclipse-wtp-common
Requires:	eclipse-wtp-servertools
Requires:	java
Requires:	jpackage-utils
Requires:	truezip-driver-file
Requires:	truezip-file

%description archives
Project Archives provides a way to define archives based on include/exclude
filesets which then gets incrementally updated allowing for fluent
deployment for any type of Eclipse project.

%package	usage
Summary:	JBoss Tools Usage Reporting

Requires:	%{name}-parent = %{version}-%{release}
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	java
Requires:	jpackage-utils

%description usage
JBoss Tools Usage reporting provides an anonymous opt-in call-back mechanism
that can be used to see how widely used plugins are, which plugin installations
have been done, where in the world and what versions of operating system, java
and other information that is available.

%package	as
Summary:	JBossAS Tools

Requires:	%{name}-archives = %{version}-%{release}
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-jmx = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	ant
Requires:	dom4j
Requires:	eclipse-emf-core
Requires:	eclipse-jdt
Requires:	eclipse-pde
Requires:	eclipse-platform
Requires:	eclipse-rcp
Requires:	eclipse-rse
Requires:	eclipse-swt
Requires:	eclipse-wtp-common
Requires:	eclipse-wtp-jeetools
Requires:	eclipse-wtp-servertools
Requires:	gnu-getopt
Requires:	icu4j-eclipse
Requires:	java
Requires:	jaxen
Requires:	jboss-as
Requires:	jboss-dmr
Requires:	jpackage-utils

%description as
Provides WTP server adapters for JBoss installations. These adapters are 
capable of deployment and providing classpaths for projects. Zipped or
exploded deployments, JMX integration, and other extensions are included.

%package	jst
Summary:	JBoss Tools Java Standard Tools

Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	ant
Requires:	eclipse-dtp
Requires:	eclipse-gef
Requires:	eclipse-jdt
Requires:	eclipse-platform
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	eclipse-wtp-jeetools
Requires:	eclipse-wtp-jst-web
Requires:	eclipse-wtp-sourceediting
Requires:	java
Requires:	jpackage-utils
Requires:	velocity
Requires:	xerces-j2

%description jst
JBoss Tools Java Standard Tools provides common tools for use in JBoss Tools
other plugins, such as Knowledge Base builder and validators for use in JSF/Web
projects.

%package	ws
Summary:	JBoss WebServices Tools and JBoss JAX-RS Tools

Requires:	%{name}-as = %{version}-%{release}
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	apache-commons-codec
Requires:	axis
Requires:	eclipse-emf-core
Requires:	eclipse-emf-xsd
Requires:	eclipse-jdt
Requires:	eclipse-platform
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	eclipse-wtp-common
Requires:	eclipse-wtp-jeetools
Requires:	eclipse-wtp-jsf
Requires:	eclipse-wtp-webservices
Requires:	icu4j-eclipse
Requires:	java
Requires:	jdom
Requires:	jpackage-utils
Requires:	resteasy
Requires:	wsdl4j


%description ws
JBoss WebServices Tools provides wizards for working with webservices
and a webservice tester view to test out both SOAP and REST services.

JBoss JAX-RS Tools provides a common navigator to browse and introspect
your JAX-RS endpoints and provide validation for JAX-RS annotations, such
as checking that parameters referenced by name actually also are declared.

%package	cdi
Summary:	JBoss CDI Tools, Apache Deltasipke Tools, Seam 3 Tools

Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-jst = %{version}-%{release}
Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	ant
Requires:	eclipse-gef
Requires:	eclipse-jdt
Requires:	eclipse-platform
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	eclipse-wtp-common
Requires:	eclipse-wtp-jeetools
Requires:	eclipse-wtp-jsf
Requires:	eclipse-wtp-sourceediting
Requires:	java
Requires:	jpackage-utils
Requires:	xerces-j2

%description cdi
Context and Dependency Injection Tools provides support for JSR-299 also know
as CDI. Adds wizards, code navigation, validation and quickfixes to work with
projects that uses CDI.

Apache Deltasipke Tools provides tooling for the CDI components released as
part of Deltaspike modules.

Seam 3 Tools provides tooling for the CDI components released as part of
Seam 3 modules such as Solder and Config. Tooling covers recognizing
these CDI components and editing the seam config xml.

%package	freemarker
Summary:	FreeMarker IDE

Requires:	%{name}-parent = %{version}-%{release}
Requires:	%{name}-usage = %{version}-%{release}
Requires:	eclipse-jdt
Requires:	eclipse-rcp
Requires:	eclipse-swt
Requires:	freemarker
Requires:	java
Requires:	jpackage-utils

%description freemarker
FreeMarkerIDE provides editor for FreeMarker templates


%prep
%setup -q -n eclipse-jbosstools-%{version}.Final

find -name '*.jar' -delete
find -name '*.class' -delete

# add symlinks to Fedora versions of removed jars
pushd archives/plugins/org.jboss.ide.eclipse.archives.core/lib/
ln -s %{_javadir}/concurrent.jar
ln -s %{_javadir}/jboss-common-core.jar
ln -s %{_javadir}/jboss-logging.jar
ln -s %{_javadir}/jbossxb.jar
ln -s %{_javadir}/truezip/truezip-driver-file.jar
ln -s %{_javadir}/truezip/truezip-driver-zip.jar
ln -s %{_javadir}/truezip/truezip-file.jar
ln -s %{_javadir}/truezip/truezip-kernel.jar
ln -s %{_javadir}/xerces-j2.jar
popd
pushd as/plugins/org.jboss.ide.eclipse.as.dmr/
ln -s %{_javadir}/jboss-dmr.jar
popd
pushd as/plugins/org.jboss.ide.eclipse.as.core/
ln -s %{_javadir}/dom4j.jar
ln -s %{_javadir}/jaxen.jar
ln -s %{_javadir}/gnu-getopt.jar
popd
pushd as/plugins/org.jboss.ide.eclipse.as.management.as71/
ln -s %{_javadir}/jboss-as/jboss-as-controller-client.jar
ln -s %{_javadir}/jboss-as/jboss-as-protocol.jar
ln -s %{_javadir}/jboss-dmr.jar
ln -s %{_javadir}/jboss-logging.jar
ln -s %{_javadir}/jboss-marshalling.jar
ln -s %{_javadir}/jboss-remoting.jar
ln -s %{_javadir}/jboss-sasl.jar
ln -s %{_javadir}/jboss-threads.jar
ln -s %{_javadir}/xnio-api.jar
ln -s %{_javadir}/xnio-nio.jar
popd
pushd ws/plugins/org.jboss.tools.ws.jaxrs.core/lib/
ln -s %{_javadir}/resteasy/jaxrs-api.jar
popd
pushd ws/plugins/org.jboss.tools.ws.ui/lib/
ln -s %{_javadir}/axis/axis.jar
ln -s %{_javadir}/axis/jaxrpc.jar
ln -s %{_javadir}/resteasy/jaxrs-api.jar
popd
pushd freemarker/plugins/org.jboss.ide.eclipse.freemarker/
ln -s %{_javadir}/freemarker.jar
popd

%patch0
%patch1

%ifarch x86_64
%patch2
%else
%patch3
%endif

%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch12
%patch13
%patch14
%patch15
%patch16
%patch17
%patch18
%patch19
%patch20
%patch21
%patch22
%patch23


%build
# build the local repository for building with maven

/bin/sh -x %{_eclipse_base}/buildscripts/copy-platform SDK %{_eclipse_base} \
 wtp-jeetools wtp-webservices eclipse-wtp-common dtp-enablement wtp-jpa \
 dtp-connectivity wtp-sourceediting org.eclipse.jst.server_ui.feature \
 eclipse-wtp-jst-web eclipse-wtp-jsf dtp-modelbase emf emf-sdk gef xsd rse 

SDK=$(cd SDK >/dev/null && pwd)

mkdir repo
repodir=$(cd repo >/dev/null && pwd)

%{_eclipse_base}/eclipse -debug -consolelog -nosplash -verbose \
 -data /tmp/workspace \
 -application org.eclipse.equinox.p2.publisher.FeaturesAndBundlesPublisher \
 -metadataRepository file:${repodir} \
 -artifactRepository file:${repodir} \
 -source ${SDK} -compress -publishArtifacts

# build everything from within build
pushd build/
for tool in parent common usage archives jmx as jst cdi ws freemarker; do
    mvn-rpmbuild install -Plocal.site,${tool} -Dlocal.site=file://${repodir} \
    		 -Dmaven.test.skip=true
done
popd


%install
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom

pushd %{build_base}

# parent POM
pushd parent/*-SNAPSHOT/
install -pm 644 parent-*.pom \
	%{buildroot}%{_mavenpomdir}/JPP-%{name}-parent.pom
	%add_maven_depmap JPP-%{name}-parent.pom -f parent
popd

for tool in common usage archives jmx as jst cdi ws freemarker; do
    install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features
    install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins

    ## POM for each tool
    pushd ${tool}/*-SNAPSHOT
	install -pm 644 ${tool}-*.pom \
	    %{buildroot}%{_mavenpomdir}/JPP-%{name}-${tool}.pom
	%add_maven_depmap JPP-%{name}-${tool}.pom -f ${tool}
    popd

    ## features
    pushd ${tool}/features
    for feat in `echo *.feature`; do
    	pushd ${feat}/*-SNAPSHOT
    	      unzip ${feat}-*-SNAPSHOT.jar -d \
	      %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features/${feat}
    	popd;
    done;
    popd

    ##plugins
    pushd ${tool}/plugins

    for plug in `echo org.jboss.*`; do
    	pushd ${plug}/*-SNAPSHOT
    	      install -p ${plug}-*-SNAPSHOT.jar \
	      %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins
    	popd;
    done;
    popd;

done;

    # org.jboss.tools.jst.web.kb is in jst/tests, but we need it
    install -p jst/tests/org.jboss.tools.jst.web.kb/*-SNAPSHOT/*-SNAPSHOT.jar \
    	    %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/plugins

popd;

%files
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files parent
%{_mavenpomdir}/JPP-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}-parent
 
%files common
%{eclipse_dropins}/%{name}-common
%{_mavenpomdir}/JPP-%{name}-common.pom
%{_mavendepmapfragdir}/%{name}-common

%files usage
%{eclipse_dropins}/%{name}-usage
%{_mavenpomdir}/JPP-%{name}-usage.pom
%{_mavendepmapfragdir}/%{name}-usage

%files archives
%{eclipse_dropins}/%{name}-archives
%{_mavenpomdir}/JPP-%{name}-archives.pom
%{_mavendepmapfragdir}/%{name}-archives

%files jmx
%{eclipse_dropins}/%{name}-jmx
%{_mavenpomdir}/JPP-%{name}-jmx.pom
%{_mavendepmapfragdir}/%{name}-jmx

%files as
%{eclipse_dropins}/%{name}-as
%{_mavenpomdir}/JPP-%{name}-as.pom
%{_mavendepmapfragdir}/%{name}-as

%files jst
%{eclipse_dropins}/%{name}-jst
%{_mavenpomdir}/JPP-%{name}-jst.pom
%{_mavendepmapfragdir}/%{name}-jst

%files cdi
%{eclipse_dropins}/%{name}-cdi
%{_mavenpomdir}/JPP-%{name}-cdi.pom
%{_mavendepmapfragdir}/%{name}-cdi

%files ws
%{eclipse_dropins}/%{name}-ws
%{_mavenpomdir}/JPP-%{name}-ws.pom
%{_mavendepmapfragdir}/%{name}-ws

%files freemarker
%{eclipse_dropins}/%{name}-freemarker
%{_mavenpomdir}/JPP-%{name}-freemarker.pom
%{_mavendepmapfragdir}/%{name}-freemarker


%changelog
* Thu Jul 26 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-1
- Initial packaging.
